//
//  Created by ITCowork Inc on 2014/02/18.
//  Copyright (c) 2014 ITCowork. All rights reserved.
//

#import "ViewController.h"
#import <CoreLocation/CoreLocation.h>
#import "IOSAnnotation.h"

@interface ViewController ()
@property (strong, nonatomic) IOSAnnotation *annotation;
@end

@implementation ViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        _annotation = nil;
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    //ピン
    self.annotation = [[IOSAnnotation alloc] initWithCoordinate:CLLocationCoordinate2DMake(40.596775, 140.953314)];
    [self.iosMapView addAnnotation:self.annotation];
    
    //マップRegion
    MKCoordinateRegion region = self.iosMapView.region;
    region.center = self.annotation.coordinate;
    region.span.latitudeDelta = 0.001;
    region.span.longitudeDelta = 0.001;
    [self.iosMapView setRegion:region animated:YES];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}


#pragma mark -
#pragma mark MKMapViewDelegate

- (void)mapView:(MKMapView *)mapView didSelectAnnotationView:(MKAnnotationView *)view
{
    if([view.annotation isKindOfClass:[IOSAnnotation class]])
    {
        //選択中のアノテーションを保持
        self.iosMapView.currentAnnotationView = (IOSAnnotationView *)view;
    }
}

- (void)mapView:(MKMapView *)mapView didDeselectAnnotationView:(MKAnnotationView *)view
{
    //選択解除されたアノテーションを破棄
    self.iosMapView.currentAnnotationView = nil;
}

- (MKAnnotationView *)mapView:(MKMapView *)mapView viewForAnnotation:(id <MKAnnotation>)annotation
{
    //Current Location Annotation
    if([annotation isKindOfClass:[MKUserLocation class]])
    {
        return nil;
    }
    //IOSAnnotation
    else if([annotation isKindOfClass:[IOSAnnotation class]])
    {
        static NSString *PinCustomID = @"CustomIdentifier";
        IOSAnnotationView *pav = (IOSAnnotationView *)[mapView dequeueReusableAnnotationViewWithIdentifier:PinCustomID];
        if(pav == nil)
        {
            pav = [[IOSAnnotationView alloc] initWithAnnotation:annotation reuseIdentifier:PinCustomID];
            pav.canShowCallout = YES;
            pav.pinColor = MKPinAnnotationColorGreen;
            pav.animatesDrop = YES;
        }
        else
        {
            pav.annotation = annotation;
        }
        return pav;
    }
    return nil;
}


- (void)mapView:(MKMapView *)mapView annotationView:(MKAnnotationView *)view calloutAccessoryControlTapped:(UIControl *)control
{
    if([view isKindOfClass:[IOSAnnotationView class]])
    {
        [[[UIAlertView alloc] initWithTitle:@"Tapped"
                                    message:nil
                                   delegate:nil
                          cancelButtonTitle:@"OK"
                          otherButtonTitles:nil, nil] show];
    }
}


@end
